% Przyklad 17.3
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

function y=delay_sum(X, fp, l, theta)
%% y=delay_sum(X, fp, l, theta)
%
% X - wielokanalowy sygnal wejsciowy, fp - czestotliwosc probkowania
% l - odleglosc mikrofonow, theta - kat wiazki
% y - sygnal wyjsciowy
v=340;                                  % predkosc dzwieku [m/s]
alfa=(theta*pi)/180;                    % stopnie/radiany
d=(l*sin(alfa))/v;                      % opoznienie [s]
N=size(X,2);                            % liczba kanalow
%--------------------------------------------------------------------------
for k=1:N
    shf(N-k+1)=floor((k-1)*abs(d)*fp);  % wektor opoznien
end
if(d<0)                                 % transformacja dla
    shf=fliplr(shf);                    % ujemnego kata wiazki
end
%--------------------------------------------------------------------------
M=size(X,1);                            % liczba probek w kanale
y1=zeros(M,1);
for k=1:N
    y1(1+shf(k):M+shf(k),k)=X(1:M,k);   % opoznienia
end
s=ones(1,N)/N;                          % przygotowanie wektora sumujacego
y=y1*s';                                % suma opoznionych kanalow / N