% Przyklad 17.4
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

function y=filter_sum(X, fp, h, l, theta)
%% y=filter_sum(X, fp, h, l, theta)
%
% X - wielokanalowy sygnal wejsciowy, fp - czestotliwosc probkowania
% h - wagi podfiltru, l - odleglosc mikrofonow, theta - kat wiazki
% y - sygnal wyjsciowy
v=340;                                  % predkosc dzwieku
alfa=(theta*pi)/180;                    % stopnie/radiany
d=(l*sin(alfa))/v;                      % opoznienie [s]
N=size(X,2);                            % liczba kanalow
%------------------------------------------------------------
for k=1:N
    shf(N-k+1)=floor((k-1)*abs(d)*fp);  % wektor opoznien
end
if(d<0)                                 % transformacja dla
    shf=fliplr(shf);                    % ujemnego kata wiazki
end
%------------------------------------------------------------
ws=size(h,2);                           % dlugosc podfiltru
dmax=floor(fp*(((k-1)*l)/v));           % max opoznienie w macierzy mikrofonowej
Mf=dmax+ws;                             % dlugosc filtru FIR
H=zeros(Mf,N);                          % macierz wag filtrow FIR
for k=1:N
    H(shf(k)+1:shf(k)+ws,k)=h;           % opoznienia
end
%------------------------------------------------------------
for k=1:N
    y1(:,k)=filter(H(:,k),1,X(:,k));    % filtracja kanalow
end
s=ones(1,N)/N;                          % przygotowanie wektora sumujacego
y=y1*s';                                % suma filtrowanych kanalow / N