% Przyklad 17.1
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

clear all; clc;                         % przygotowanie obliczen
%------------------------ Parametry macierzy ------------------------------
v=340;                                  % predkosc dzwieku [m/s]
l=0.05;                                 % odleglosc mikrofonow [m]
N=8;                                    % liczba mikrofonow
f=1000;                                 % czestotliwosc [Hz]
%--------------------------------------------------------------------------
m=1;
for theta=-pi:0.01:pi                   % zmiana kata -pi do +pi
    sum=0;
    %re=0; im=0;
    for k=0:N-1                         % obliczenie czulosci macierzy
        sum=sum+exp(i*2*pi*f*k*l*sin(theta)/v); % na podstawie wzoru (17.1)
        %re=re+cos(2*pi*f*k*l*sin(theta)/v);    % na podstawie wzoru (17.4)
        %im=im+sin(2*pi*f*k*l*sin(theta)/v);    % na podstawie wzoru (17.4)
    end
    y(m)=(abs(sum/N));                  % modul/N - na podstawie wzoru (17.1)
    %y(m)=sqrt(re*re+im*im)/N;          % modul/N - na podstawie wzoru (17.4)
    m=m+1;
end
%--------------------------------------------------------------------------
ph=linspace(-pi,pi,m-1);                % przestrzen fazy dla wykresu
polar(ph,y,'b');                        % wykres biegunowy
xlabel(['N=',num2str(N),', l=',num2str(l*100),'cm', ', f=',num2str(f/1000),'kHz']);