% Przyklad 17.7
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

clear all; clc;
l=0.08;                                 % odleglosc mikrofonow w macierzy
k=3;                                    % kanal do obliczenia TDOA wzgledem kanalu 1
[X, fp] = wavread('mch_truck.wav');     % odczyt pliku
NFFT=16384;                             % rozmiar okna FFT
K=size(X,1);                            % liczba probek w pojedynczym kanale
wn = window(@hann,NFFT);                % okno dla FFT
j=1;
for(i=0:(NFFT/2):K-NFFT)                % przesuwanie okna z zakladka 1/2 dlugosci okna
    XW(1:NFFT,:)=X(i+1:i+NFFT,:);       % wycinek sygnalu o dlugosci okna
    xw1=wn.*XW(:,1);                    % przemnozenie 1 kanalu przez okno (wn)
    xw2=wn.*XW(:,1+k);                  % przemnozenie k-tego kanalu przez okno (wn)
    theta(j)=tdoa(xw1, xw2, fp, k*l, 1);% obliczenie TDOA dla 1 zrodla sygnalu
    j=j+1;
end
tm=linspace(0,j*(NFFT/2)/fp,j-1);       % przestrzen czasu
plot(tm, theta,'b*-');
xlabel(['Czas (s)']); ylabel(['Kat (stopnie)']); grid on;