% Przyklad 17.9
%
% Cyfrowe przetwarzanie sygnalow. Podstawy, multimedia, transmisja. PWN, Warszawa, 2014.
% Rozdzial 17. Macierze mikrofonowe i glosnikowe. 
% Autor rozdzialu: Daniel Krol.

clear all; clc;                             % przygotowanie obliczen
%------------------------ Parametry macierzy ------------------------------
l=0.02;                                     % odleglosc mikrofonow w macierzy
%thetaA=30;                                 % kat wiazki A (-90 - +90)
%thetaB=0;                                  % kat wiazki B (-90 - +90)
%thetaC=-45;                                % kat wiazki C (-90 - +90)
%--------------------------------------------------------------------------
[X, fp] = wavread('mch_separation.wav');
%------------------------------ TDOA --------------------------------------
N=size(X,2);                                % liczba kanalow w pliku
theta=tdoa(X(:,1), X(:,N), fp, (N-1)*l, 3); % obliczenie 3 katow na podstawie TDOA
thetaA=theta(1)
thetaB=theta(2)
thetaC=theta(3)
%----------------------- Narrowband Beamforming ---------------------------
%wagi filtru pasmowo-przepustowego (Hamming 10rzad 2kHz-16kHz)
hnb=[-0.00965926 0 -0.0309026 -0.153538 0.18252 0.603916 0.18252 -0.153538 -0.0309026 0 -0.00965926];
%----------------------- Broadband Beamforming ----------------------------
%wagi dla delay-sum [1 0 0 0 ...]
hbb=[1];
%--------------------------------------------------------------------------
fsum1=filter_sum(X, fp, hnb, l, thetaA);
fsum2=filter_sum(X, fp, hnb, l, thetaB);
fsum3=filter_sum(X, fp, hnb, l, thetaC);
%--------------------------- Spektrogram ----------------------------------
amin=1000;                                  % dynamika spektrogramu

[C,f,t]=specgram(X(:,1),1024,fp,256,192);   % pojedynczy kanal
subplot(2,2,1);
bmin=max(max(abs(C)))/amin;
imagesc(t,f,20*log10(max(abs(C),bmin)/bmin));
axis xy; xlabel('Czas (s)'); ylabel('Czestotliwosc (Hz)'); colorbar;

[C,f,t]=specgram(fsum1,1024,fp,256,192);     % wyjscie filter-sum 1
subplot(2,2,2);
bmin=max(max(abs(C)))/amin;
imagesc(t,f,20*log10(max(abs(C),bmin)/bmin));
axis xy; xlabel('Czas (s)'); ylabel('Czestotliwosc (Hz)'); colorbar;

[C,f,t]=specgram(fsum2,1024,fp,256,192);     % wyjscie filter-sum 2
subplot(2,2,3);
bmin=max(max(abs(C)))/amin;
imagesc(t,f,20*log10(max(abs(C),bmin)/bmin));
axis xy; xlabel('Czas (s)'); ylabel('Czestotliwosc (Hz)'); colorbar;

[C,f,t]=specgram(fsum3,1024,fp,256,192);     % wyjscie filter-sum 3
subplot(2,2,4);
bmin=max(max(abs(C)))/amin;
imagesc(t,f,20*log10(max(abs(C),bmin)/bmin));
axis xy; xlabel('Czas (s)'); ylabel('Czestotliwosc (Hz)'); colorbar;
%--------------------------------------------------------------------------
wavwrite(fsum1, fp, 'fs_1.wav');            % zapis wyjscia 1 do pliku
wavwrite(fsum2, fp, 'fs_2.wav');            % zapis wyjscia 2 do pliku
wavwrite(fsum3, fp, 'fs_3.wav');            % zapis wyjscia 3 do pliku
sound(fsum1, fp);                            % odtwarzanie wyjscia 1
sound(fsum2, fp);                            % odtwarzanie wyjscia 2
sound(fsum3, fp);                            % odtwarzanie wyjscia 3